//公共结构体和枚举

export enum ScrollViewEventMap {
    "scroll-to-top" = 0,
    "scroll-to-bottom" = 1,
    "scroll-to-left" = 2,
    "scroll-to-right" = 3,
    "scrolling" = 4,
    "bounce-bottom" = 6,
    "bounce-left" = 7,
    "bounce-right" = 8,
    "bounce-top" = 5,
    "scroll-ended" = 9,
    "touch-up" = 10,
    "scroll-ended-with-threshold" = 11,
    "scroll-began" = 12,
}

// /** 公告 */
export interface BulletinEnum {
    content: string;       //公告内容
    img: null;        //公告图片；可空
}

/** 弹窗类型 */
export enum TipsOpereteEnum {
    yes = 0,
    yes_no = 1
}

/** 物品类型 */
export enum ItemEnum {
    user = "user",       //货币
    material = "material",       //材料
    equip = "equip",          //装备
    role = "role",          //英雄
}
export enum LanguageType {
    Zh = "Zh",
    En = "En",
}
export interface BaseItem {
    conf: {};
    id: string;
    count: number;
    type: ItemEnum;
}

// 奖品[物品类型(ItemEnum),物品编号，物品数量]  []
export type AwardData = [string, string, number]
/** 装备部位 */
export enum EquipSlotEnum {
    weapon = 1,     //武器
    helmet = 2,     //头盔
    armor = 3,      //盔甲
    jewelry = 4,    //首饰
}

/** 属性类型 */
export enum AttrAddTypeEnum {
    reality = 1,     //实际加成
    percent = 2,     //百分比加成
}

/** 属性 */
export const AttrEnum = {
    attack: { type: AttrAddTypeEnum.reality, name: "攻击", desc: "攻击", url: "attack_ico" },
    defence: { type: AttrAddTypeEnum.reality, name: "防御", desc: "防御", url: "defence_ico" },
    hp: { type: AttrAddTypeEnum.reality, name: "生命", desc: "生命", url: "hp_ico" },
    speed: { type: AttrAddTypeEnum.reality, name: "速度", desc: "速度", url: "speed_ico" },
    broken: { type: AttrAddTypeEnum.reality, name: "破甲", desc: "破甲", url: "broken_ico" },
    power: { type: AttrAddTypeEnum.reality, name: "士气", desc: "士气", url: "power_ico" },
    hp_p: { type: AttrAddTypeEnum.percent, name: "生命加成", desc: "生命加成", url: "hp_p_ico" },
    attack_p: { type: AttrAddTypeEnum.percent, name: "攻击加成", desc: "攻击加成", url: "attack_p_ico" },
    defence_p: { type: AttrAddTypeEnum.percent, name: "防御加成", desc: "防御加成", url: "defence_p_ico" },
    hit: { type: AttrAddTypeEnum.percent, name: "命中率", desc: "命中率", url: "hit_ico" },
    miss: { type: AttrAddTypeEnum.percent, name: "闪避率", desc: "闪避率", url: "miss_ico" },
    crite: { type: AttrAddTypeEnum.percent, name: "暴击率", desc: "暴击率", url: "crite_ico" },
    decrite: { type: AttrAddTypeEnum.percent, name: "抗暴率", desc: "抗暴率", url: "decrite_ico" },
    critedamage: { type: AttrAddTypeEnum.percent, name: "暴击伤害", desc: "暴击伤害", url: "critedamage_ico" },
    adddamage: { type: AttrAddTypeEnum.percent, name: "伤害加成", desc: "攻击伤害加成", url: "adddamage_ico" },
    dedamage: { type: AttrAddTypeEnum.percent, name: "伤害减免", desc: "伤害减免", url: "dedamage_ico" },
    suck: { type: AttrAddTypeEnum.percent, name: "吸血", desc: "吸血", url: "suck_ico" },
    thorns: { type: AttrAddTypeEnum.percent, name: "反伤", desc: "反伤", url: "thorns_ico" },
    block: { type: AttrAddTypeEnum.percent, name: "反伤", desc: "反伤", url: "thorns_ico" },
}