import { _decorator, Label, tween, UIOpacity } from 'cc';
import { BaseView } from '../../../framework/layer/BaseView';
import { StringUtil } from '../../../framework/util/StringUtil';
import List from '../../../framework/list/List';
import { Framework } from '../../../framework/Framework';
import { Equip } from '../../data/EquipData';

const { ccclass, property } = _decorator;

@ccclass('HeroFate')
export class HeroFate extends BaseView {
	@property({ type: Label, tooltip: "关闭提示" })
	closeTips: Label = null;

	@property({ type: Label, tooltip: "标题" })
	titieTx: Label = null;

	@property({ type: List, tooltip: "列表" })
	itemList: List = null;

	private _fettersList = [];

	start() {

	}
	protected onLoad() {
		super.onLoad();
		this.closeTips.string = StringUtil.getLanguageData('点击空白关闭');
		this.titieTx.string = StringUtil.getLanguageData('装备选择');

		this.closeTips.node.getComponent(UIOpacity).opacity = 0;

		// Framework.event.addEvent(GameEvent.EquipWearChange, () => {
		// 	Framework.layer.close(this);
		// }, this);
	}

	protected onDestroy() {

	}

	//UI开打时会调用,如果有初始化代码应该放到此函数
	onOpen(data) {
		tween(this.closeTips.node.getComponent(UIOpacity))
			.to(1, { opacity: 255 })
			.to(1.2, { opacity: 10 })
			.union()
			.repeatForever()
			.start()
			
	}

	//UI关闭时会调用,该函数在onDestroy前调用
	onClose() {

	}

	//框架管理UI层级时会调用,可根据UI情况修改
	onShow() {
		super.onShow();
	}

	//框架管理UI层级时会调用,可根据UI情况修改
	onHide() {
		super.onHide();
	}

	//UI事件处理
	private onTouchButton(event: Event) {
		//Framework.audio.playEffect(AudioID.Click);
		let target: any = event.target;
		if (target.name == 'mask') {
			Framework.layer.close(this);
		}
	}

	onEventList(item, idx) {
		// item.getComponent(HeroFateItem).refreshItem(this._equipsData[idx], this._curEquip);
	}
}